/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2002 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.dynamo.security;

import java.security.Principal;
import java.security.acl.AclNotFoundException;
import com.silverwrist.dynamo.except.*;
import com.silverwrist.dynamo.iface.*;

public interface SecurityReferenceMonitor
{
  public DynamoAcl getAcl(int aclid) throws DatabaseException, AclNotFoundException;

  public DynamoAcl createAcl(String name, Principal owner) throws DatabaseException;

  public DynamoAce createAce() throws DatabaseException;

  public DynamoPermission createPermission(String namespace, String name) throws DatabaseException;

  public boolean testPermission(int aclid, DynamoUser user, String perm_namespace, String perm_name)
      throws DatabaseException;

  public DynamoUser getAdminUser();

  public DynamoGroup getAdminGroup();

  public DynamoAcl getGlobalAcl();

  public boolean isOwnerOfAcl(int aclid, DynamoUser user) throws DatabaseException;

  public DynamoGroup getAllUsersGroup();

  public DynamoGroup getVerifiedUsersGroup();

} // end interface SecurityReferenceMonitor
